/*******************************************************************************
* 
*
********************************************************************************
* Copyright 2012, Cypress Semiconductor Corporation. All rights reserved.
* This software is owned by Cypress Semiconductor Corporation and is protected
* by and subject to worldwide patent and copyright laws and treaties.
* Therefore, you may use this software only as provided in the license agreement
* accompanying the software package from which you obtained this software.
* CYPRESS AND ITS SUPPLIERS MAKE NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
* WITH REGARD TO THIS SOFTWARE, INCLUDING, BUT NOT LIMITED TO, NONINFRINGEMENT,
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*******************************************************************************/

#include <device.h>
#include "stdio.h"

#define RX_BUFFER_LEN  		16
#define TRUE				1
#define	FALSE				0

void main()
{
    /* incoming buffer */
	uint8 rx_buffer[RX_BUFFER_LEN];

	/* number of the next emty byte in rx buffer */
	uint8 rx_buffer_index = 0;

	uint8 USBUART_MESSAGE_READY = FALSE;	// message completed flag
    
    
    /* Enable Global Interrupts */
    CyGlobalIntEnable;                        

    /* Start USBFS Operation with 3V operation */
    USBUART_1_Start(0, USBUART_1_3V_OPERATION);

    
    /* Wait for Device to enumerate */
    while(!USBUART_1_GetConfiguration());
	
    /* Enumeration is done, enable OUT endpoint for receive data from Host */
    USBUART_1_CDC_Init();
   
    /* Main Loop: */
    for(;;)
    {
		/* Wait till data is received */
       if (USBUART_1_DataIsReady())
        {
			uint8 i;
			uint8 tempchar;	// temorarily holds the received char
			uint8 count = 0;// number of incoming bytes in usbuart message
			
			/* get the number of received bytes */
			count = USBUART_1_GetCount();
			
			/* get chars into the buffer */
			for (i=0; i<count; i++)
			{
				tempchar = USBUART_1_GetChar;
				
				/* terminate string when ... */
				if (tempchar == '*')
				{
					/* set the flag */
					USBUART_MESSAGE_READY = TRUE;
					
					/* terminate the string */
					rx_buffer[rx_buffer_index] = '\0';
					
					/* reset rx buffer index */
					rx_buffer_index = 0;
				}
				
				/* if overflow happened */
				else if(rx_buffer_index > RX_BUFFER_LEN)
				{
					rx_buffer_index = 0;
				}
				
				/* collect the char into the buffer */
				else
				{
					/* put char into the buffer */
					rx_buffer[rx_buffer_index] = tempchar;
					
					/* where the next char will be saved */
					rx_buffer_index++;
				}
			}
         
        }
		
		/* echo the incoming message back */
		if (USBUART_MESSAGE_READY)
		{
			while(USBUART_1_CDCIsReady() == 0u);    /* Wait till component is ready to send more data to the PC */ 
			USBUART_1_PutString(rx_buffer);
			
			while(USBUART_1_CDCIsReady() == 0u);    /* Wait till component is ready to send more data to the PC */ 
			USBUART_1_PutString("\r\n");
			
			USBUART_MESSAGE_READY = FALSE;
		}
     }
   }